import { Camera, CameraOptions } from './Camera';
import { Vec2, Vec3 } from 'wtc-math';
declare type DollyCameraOptions = {
    element?: any;
    enabled?: boolean;
    target?: Vec3;
    ease?: number;
    inertia?: number;
    enableRotate?: boolean;
    rotateSpeed?: number;
    autoRotate?: boolean;
    autoRotateSpeed?: number;
    enableZoom?: boolean;
    zoomSpeed?: number;
    zoomStyle?: string;
    enablePan?: boolean;
    panSpeed?: number;
    minPolarAngle?: number;
    maxPolarAngle?: number;
    minAzimuthAngle?: number;
    maxAzimuthAngle?: number;
    minDistance?: number;
    maxDistance?: number;
};
declare class DollyCamera extends Camera {
    element: any;
    enabled: boolean;
    target: Vec3;
    zoomStyle: string;
    minDistance: number;
    maxDistance: number;
    enableRotate: boolean;
    autoRotate: boolean;
    enableZoom: boolean;
    enablePan: boolean;
    ease: number;
    inertia: number;
    rotateSpeed: number;
    autoRotateSpeed: number;
    zoomSpeed: number;
    panSpeed: number;
    minPolarAngle: number;
    maxPolarAngle: number;
    minAzimuthAngle: number;
    maxAzimuthAngle: number;
    sphericalDelta: Vec3;
    sphericalTarget: Vec3;
    spherical: Vec3;
    panDelta: Vec3;
    offset: Vec3;
    rotateStart: Vec2;
    panStart: Vec2;
    dollyStart: Vec2;
    state: number;
    mouseButtons: {
        ORBIT: number;
        ZOOM: number;
        PAN: number;
    };
    static STATE_NONE: number;
    static STATE_ROTATE: number;
    static STATE_DOLLY: number;
    static STATE_PAN: number;
    static STATE_DOLLY_PAN: number;
    constructor({ element, enabled, target, ease, inertia, enableRotate, rotateSpeed, autoRotate, autoRotateSpeed, enableZoom, zoomSpeed, zoomStyle, enablePan, panSpeed, minPolarAngle, maxPolarAngle, minAzimuthAngle, maxAzimuthAngle, minDistance, maxDistance }?: DollyCameraOptions, cameraOptions?: CameraOptions);
    setPosition(x: any, y: any, z: any): void;
    update(): void;
    forcePosition(): void;
    getZoomScale(): number;
    panLeft(distance: any, m: any): void;
    panUp(distance: any, m: any): void;
    pan(deltaX: any, deltaY: any): void;
    dolly(dollyScale: any): void;
    handleAutoRotate(): void;
    handleMoveRotate(x: any, y: any): void;
    handleMouseMoveDolly(e: any): void;
    handleMovePan(x: any, y: any): void;
    handleTouchStartDollyPan(e: any): void;
    handleTouchMoveDollyPan(e: any): void;
    onMouseDown(e: any): void;
    onMouseMove(e: any): void;
    onMouseUp(): void;
    onMouseWheel(e: any): void;
    onTouchStart(e: any): void;
    onTouchMove(e: any): void;
    onTouchEnd(e: any): void;
    onContextMenu(e: any): void;
    addHandlers(): void;
    removeHandlers(): void;
}
export { DollyCamera };
