import { WTCGLRenderingContext } from '../types';
import { Program } from './Program';
/**
 * To-Do
 * Update this class to take care of its own internal state (like render targets) rather than relying on geo to control state
 */
declare class TransformFeedback {
    VAOs: [WebGLVertexArrayObject, WebGLVertexArrayObject];
    TFBs: [WebGLTransformFeedback, WebGLTransformFeedback];
    BufferRefs: {
        [key: string]: {
            i: number;
            buffer: WebGLBuffer;
        };
    }[];
    constructor(gl: WTCGLRenderingContext, { program, transformFeedbacks }?: {
        program?: Program;
        transformFeedbacks?: {
            [key: string]: {
                size: number;
                type?: GLenum;
                normalize?: boolean;
                stride?: number;
                offset?: number;
                buffer?: WebGLBuffer;
                data: Float32Array;
                varying: string;
                usage?: GLenum;
                buffertype?: GLenum;
            };
        };
    });
}
export { TransformFeedback };
