import { WTCGLRenderingContext } from '../types';
import { RenderTarget } from '../core/RenderTarget';
declare class Framebuffer {
    #private;
    static TEXTYPE_FLOAT: number;
    static TEXTYPE_UNSIGNED_BYTE: number;
    static TEXTYPE_HALF_FLOAT_OES: number;
    static IMAGETYPE_REGULAR: number;
    static IMAGETYPE_TILING: number;
    static IMAGETYPE_MIRROR: number;
    gl: WTCGLRenderingContext;
    name: string;
    minFilter: any;
    magFilter: any;
    premultiplyAlpha: any;
    constructor(gl: any, { name, width, height, dpr, tiling, texdepth, minFilter, magFilter, premultiplyAlpha, data }?: {
        name?: string;
        width?: number;
        height?: number;
        dpr?: number;
        tiling?: number;
        texdepth?: number;
        minFilter?: any;
        magFilter?: any;
        premultiplyAlpha?: boolean;
        data?: any;
    });
    resize(width: any, height: any): void;
    createFrameBuffer(): RenderTarget;
    swap(): void;
    render(renderer: any, { scene, camera, update, clear, viewport }: {
        scene: any;
        camera: any;
        update?: boolean;
        clear: any;
        viewport?: any;
    }): void;
    get wrap(): number;
    get type(): number;
    get read(): any;
    get write(): any;
    set data(value: any);
    get data(): any;
    set width(value: number);
    get width(): number;
    set height(value: number);
    get height(): number;
    set pxRatio(value: number);
    get pxRatio(): number;
    set dpr(value: number);
    get dpr(): number;
    set tiling(value: number);
    get tiling(): number;
    set texdepth(value: number);
    get texdepth(): number;
}
export { Framebuffer };
