import { WTCGLRenderingContext } from '../../types';
import { Renderer } from '../../core/Renderer';
import { Program } from '../../core/Program';
import { Mesh } from '../../core/Mesh';
import { Uniform } from '../../core/Uniform';
import { Vec2 } from 'wtc-math';
interface WTCGLUniformArray {
    [index: string]: Uniform;
}
declare class FragmentShader {
    #private;
    uniforms: WTCGLUniformArray;
    dimensions: Vec2;
    autoResize: boolean;
    onBeforeRender: (t: number) => {};
    onAfterRender: (t: number) => {};
    u_time: Uniform;
    u_resolution: Uniform;
    gl: WTCGLRenderingContext;
    renderer: Renderer;
    program: Program;
    mesh: Mesh;
    lastTime: number;
    constructor({ vertex, fragment, dimensions, container, autoResize, uniforms, onInit, onBeforeRender, onAfterRender, rendererProps }?: {
        vertex?: string;
        fragment?: string;
        dimensions?: Vec2;
        container?: HTMLElement;
        autoResize?: boolean;
        uniforms?: WTCGLUniformArray;
        onInit?: (renderer: any) => void;
        onBeforeRender?: (delta: number) => void;
        onAfterRender?: (delta: number) => void;
        rendererProps?: any;
    });
    resize(): void;
    resetTime(): void;
    render(t: any): void;
    set post(p: any);
    get post(): any;
    set playing(v: boolean);
    get playing(): boolean;
}
export { FragmentShader };
