import { WTCGLRenderingContext } from '../../types';
import { Renderer } from '../../core/Renderer';
import { Program } from '../../core/Program';
import { Mesh } from '../../core/Mesh';
import { Vec2 } from 'wtc-math';
import { PointCloud } from '../../geometry/PointCloud';
import { Camera } from "../../core/Camera";
declare class ParticleSimulation {
    #private;
    uniforms: any;
    dimensions: any;
    autoResize: boolean;
    onBeforeRender: any;
    onAfterRender: any;
    u_time: any;
    u_resolution: any;
    gl: WTCGLRenderingContext;
    renderer: Renderer;
    program: Program;
    mesh: Mesh;
    textureSize: number;
    particles: number;
    textureArraySize: number;
    simDimensions: number;
    references: any;
    properties: any;
    cloud: PointCloud;
    lastTime: number;
    constructor({ vertex, fragment, dimensions, container, autoResize, uniforms, onBeforeRender, onAfterRender, textureSize, simDimensions, createGeometry, rendererProps }?: {
        vertex?: string;
        fragment?: string;
        dimensions?: Vec2;
        container?: HTMLElement;
        autoResize?: boolean;
        uniforms?: {};
        onBeforeRender?: (t: any) => void;
        onAfterRender?: (t: any) => void;
        textureSize?: number;
        simDimensions?: number;
        createGeometry?: any;
        rendererProps?: {};
    });
    createGeometry(): void;
    render(t: any): void;
    resize(): void;
    set post(p: any);
    get post(): any;
    set playing(v: boolean);
    get playing(): boolean;
    set camera(v: Camera);
    get camera(): Camera;
    set update(v: boolean);
    get update(): boolean;
    set sort(v: boolean);
    get sort(): boolean;
    set frustumCull(v: boolean);
    get frustumCull(): boolean;
    set clear(v: boolean);
    get clear(): boolean;
    set viewport(v: [Vec2, Vec2]);
    get viewport(): [Vec2, Vec2];
}
export { ParticleSimulation };
